/***********************************************************************
|  Genealogy management system
|  Copyright (C) Karl Dahlke 1994
|  This software may be freely used by anyone for any personal,
|  non-profit purpose, and may be freely distributed to others.
|*********************************************************************/

/* startup.c: startup routines for genealogy database */

#include "structs.h"

main(argc, argv)
char **argv;
{
char c;
int pid;

#ifdef MSDOS
/* I'd love to close the file descriptors on the serial and parallel ports,
 * and use them for something a little more useful,
 * such as the name or person table.
 * However, all you have to do is hit control-p,
 * or some other printkey directive,
 * and output is automatically shoveled into file descriptor 3.
 * This subtle mechanism destroyed my name table,
 * and it took me a long time to track down the bug and repair the corruption.
 * So we have to leave these file descriptors open (wasted).
 *        close(3);
 *        close(4);
*/
#endif

#ifndef MSDOS
pid = getpid();
sprintf(temp_textfile+7, "%d", pid);
sprintf(temp_10file+7, "%d", pid);
#endif

if(argc > 2) argv[1] = "jkl";
if(setjmp(main_menu))
exit(1);

cd_basedir("gng");
serial_dirs("data", "idx", "data", "/tmp");
#ifdef MSDOS
serial_mode(0,0);
#else
serial_mode(1,0);
#endif

checkversion();

if(argc == 2) {
run_admin_command(argv[1]);
exit(0);
}

setjmp(main_menu);

if(!cur_prs_rowid) {
if(db_is_empty()) {
struct name *n;
struct qknote bp;

clearscreen();
printf("The database is currently empty.\nLet's begin by enterring information about you.\n\n");
n = getname("your birth (maiden) name", 0, 0);
n->birth = 1;

init_0(&cur_prs);
cur_prs.txtc1 = 1;
lowdate = 1900*YEAR_DAY_RATIO;
highdate = 2100*YEAR_DAY_RATIO;
do {
cur_prs.birth = getdate("your birthdate",
"Your birthdate must be contemporary, sometime within the last century", 0);
} while(!cur_prs.birth);
c = promptfor("Gender: ", "mMfF");
cur_prs.sex = tolower(c);
nl();

init_0(&bp);
getqknote('b');
strcpy(bp.note, line);
bp.ntype = 'b';

/* everything collected, add the first person */
cur_prs_rowid = insupd_person(NULLKEY, &cur_prs);
n->prsid = cur_prs_rowid;
bp.prsid = cur_prs_rowid;
insupd_name(NULLKEY, n);
if(bp.note[0])
insupd_qknote(NULLKEY, &bp);

set_curperson(cur_prs_rowid);

} else { /* end adding first person */
set_curperson(searchfor(NULL));
}
} /* current person was 0 */

while(1) {
topscreen(stdout, 0);
command();
} /* infinite loop */
} /* main */

long searchfor(n1)
struct name *n1;
{
struct rel_cursor c;
char *sn;
struct name *n2;
char fname[NAMELEN], mname[NAMELEN], lname[NAMELEN];
int flen, mlen, llen;
int i,j,num1, base;
struct person *p;
long prsid, l;
char cmd;
char lrs[15];

top:
if(!n1) {
nl();
n1 = getname("search name", 1, 0);
}

if(n1->search == 2) {
/* you can tell this @ feature was added later (kludge). */
i = 0;
prsid = cur_prs_rowid;
for(sn=line; *sn; ++sn) {
cmd = *sn;
if(cmd == '>') {
i = 1;
continue;
}
if(cmd == 'y' || cmd == 'o') {
l = getdad(prsid);
if(!l) l = getmom(prsid);
if(!l) break;
spreadout(l, 'c');
for(j=0; j<spreadnum; ++j)
if(spreaddata[j].prsid == prsid) break;
j += cmd == 'o' ? -1 : 1;
if(j < 0 || j >= spreadnum) break;
prsid = spreaddata[j].prsid;
i = 0;
continue;
}
j = 0;
if(isdigit(cmd)) {
j = cmd-'0';
cmd = 'c';
}
spreadout(prsid, cmd);
num1 = spreadnum;
/* how many match the adoption criteria? */
if(num1 && (cmd == 'm' || cmd == 'f')) {
if(!i) num1 = 1;
if(spreaddata[0].adopt != i) --num1; /* first one doesn't count */
}
if(!num1 || j > num1) break;
if(!j) {
if(num1 == 1) j = 1;
else {
/* need a digit, ambiguous */
if(!isdigit(sn[1])) break;
j = *++sn - '0';
if(j > num1) break;
}
}
if((cmd == 'm' || cmd == 'f') &&
spreaddata[0].adopt != i)
++j;
prsid = spreaddata[j-1].prsid;
i = 0;
}
if(*sn) {
*++sn = 0;
printf("\nCannot complete the chain, no relation found at %s?\n", line);
longjmp(main_menu,1);
}
return prsid;
} /* end @ feature */

strcpy(fname, fld1);
strcpy(mname, fld2);
strcpy(lname, fld3);
flen = strlen(fld1);
mlen = strlen(fld2);
llen = strlen(fld3);
if(flen < 2 || llen < 3) {
printf("Short first or last name, search may be slow ...\n");
start_scan(&c, NULL, STRUCT_name, NULL, NULLKEY, NULL);
} else {
start_scan(&c, NULL, STRUCT_name, NULL, n1->hashval, "hashval");
}

spreadnum = 0;
while(n2 = (struct name *) next_scan(&c)) {
splitstring(n2->fullname);
if(ci_strncmp(fld1, fname, flen)) continue;
if(mlen && strlen(fld2) &&
ci_strncmp(fld2, mname, mlen)) continue;
if(ci_strncmp(fld3, lname, llen)) continue;

spread_insert(c.rowid, n2->prsid, 0L, 0);
} /* end matching names */
end_scan(&c);

if(!spreadnum) {
printf("Nobody matches the name %s %s %s, please try again\n",
fname, mname, lname);
n1 = 0;
goto top;
}

if(spreadnum == 1) return spreaddata[0].prsid;
if(spreadnum == SPREADMAX)
printf("\nOnly the first %d people will be displayed\n", SPREADMAX);

base = 0;
while(1) {
nl();
for(i=0; i<9; ++i) {
if(base+i >= spreadnum) break;
prsid = spreaddata[base+i].prsid;
birthname(prsid);
fld1[10] = 0;
fld3[10] = 0;
printf("%d %s %s:", i+1, fld1, fld3);
p = select_person(prsid);
if(p->birth) printf(" %s", datestring(p->birth));
sn = shortnote(prsid, 'b');
if(sn) printf(", %s", sn);
nl();
}
nl();
printf("Enter a digit to select a person or r to restart the search");
strcpy(lrs, "r123456789");
lrs[i+1] = 0;
if(base) {
printf(",\nl to review the last page");
strcat(lrs, "l");
}
if(base+i < spreadnum) {
printf(",%cn to review the next page", base ? ' ' : '\n');
strcat(lrs, "n");
}
cmd = promptfor(":", lrs);
nl();

if(isdigit(cmd))
return spreaddata[base + cmd - '0' - 1].prsid;

if(cmd == 'l') { base -= 10; continue; }
if(cmd == 'n') { base += 10; continue; }

n1 = 0;
goto top;
} /* end paging through choices */
/* not reached */
} /* searchfor */

ZC_serial_grabblock()
{
eprint("grabblock function should never be called");
} /* ZC_serial_grabblock */

stubgo()
{
struct rel_cursor c;
struct name *n;
int val;

val = evaluate(74L,75L,1, 1);
printf("%d\n", val);
} /* stubgo */

